#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Interface to KNotify that is used for Make Progress! plasmoid
#
# Takes 4 arguments:
# 1. Message type, one of "Notification", "Warning" or "Error"
# 2. Title of popup window.
# 3. Message text.
# 4. Timeout.
#
# @license GPL 2 (http://www.gnu.org/licenses/gpl.html)
# @author Nikita Melnichenko [http://nikita.melnichenko.name]
# @copyright Copyright 2010, Nikita Melnichenko

import sys
import dbus

# check number of args
if len(sys.argv) < 5:
	sys.exit(1)

# save args to vars
message_type = sys.argv[1]
title = sys.argv[2]
message = sys.argv[3]
timeout = int(sys.argv[4])

# determine event type by message type
event_type = "notification"
if message_type == "Warning":
	event_type = "warning"
if message_type == "Error":
	event_type = "fatalerror"

# dbus call to knotify
notify_object = dbus.SessionBus().get_object("org.kde.knotify", "/Notify")
notify_object.event(event_type, "kde", [], title, message, [0,0,0,0], [], timeout, 0, dbus_interface="org.kde.KNotify")
